"use strict";Object.defineProperty(exports, "__esModule", {value: true});var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};

// node_modules/_js-base64@3.7.2@js-base64/base64.mjs
var version = "3.7.2";
var VERSION = version;
var _hasatob = typeof atob === "function";
var _hasbtoa = typeof btoa === "function";
var _hasBuffer = typeof Buffer === "function";
var _TD = typeof TextDecoder === "function" ? new TextDecoder() : void 0;
var _TE = typeof TextEncoder === "function" ? new TextEncoder() : void 0;
var b64ch = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
var b64chs = Array.prototype.slice.call(b64ch);
var b64tab = ((a) => {
  let tab = {};
  a.forEach((c, i) => tab[c] = i);
  return tab;
})(b64chs);
var b64re = /^(?:[A-Za-z\d+\/]{4})*?(?:[A-Za-z\d+\/]{2}(?:==)?|[A-Za-z\d+\/]{3}=?)?$/;
var _fromCC = String.fromCharCode.bind(String);
var _U8Afrom = typeof Uint8Array.from === "function" ? Uint8Array.from.bind(Uint8Array) : (it, fn = (x) => x) => new Uint8Array(Array.prototype.slice.call(it, 0).map(fn));
var _mkUriSafe = (src) => src.replace(/=/g, "").replace(/[+\/]/g, (m0) => m0 == "+" ? "-" : "_");
var _tidyB64 = (s) => s.replace(/[^A-Za-z0-9\+\/]/g, "");
var btoaPolyfill = (bin) => {
  let u32, c0, c1, c2, asc = "";
  const pad = bin.length % 3;
  for (let i = 0; i < bin.length; ) {
    if ((c0 = bin.charCodeAt(i++)) > 255 || (c1 = bin.charCodeAt(i++)) > 255 || (c2 = bin.charCodeAt(i++)) > 255)
      throw new TypeError("invalid character found");
    u32 = c0 << 16 | c1 << 8 | c2;
    asc += b64chs[u32 >> 18 & 63] + b64chs[u32 >> 12 & 63] + b64chs[u32 >> 6 & 63] + b64chs[u32 & 63];
  }
  return pad ? asc.slice(0, pad - 3) + "===".substring(pad) : asc;
};
var _btoa = _hasbtoa ? (bin) => btoa(bin) : _hasBuffer ? (bin) => Buffer.from(bin, "binary").toString("base64") : btoaPolyfill;
var _fromUint8Array = _hasBuffer ? (u8a) => Buffer.from(u8a).toString("base64") : (u8a) => {
  const maxargs = 4096;
  let strs = [];
  for (let i = 0, l = u8a.length; i < l; i += maxargs) {
    strs.push(_fromCC.apply(null, u8a.subarray(i, i + maxargs)));
  }
  return _btoa(strs.join(""));
};
var fromUint8Array = (u8a, urlsafe = false) => urlsafe ? _mkUriSafe(_fromUint8Array(u8a)) : _fromUint8Array(u8a);
var cb_utob = (c) => {
  if (c.length < 2) {
    var cc = c.charCodeAt(0);
    return cc < 128 ? c : cc < 2048 ? _fromCC(192 | cc >>> 6) + _fromCC(128 | cc & 63) : _fromCC(224 | cc >>> 12 & 15) + _fromCC(128 | cc >>> 6 & 63) + _fromCC(128 | cc & 63);
  } else {
    var cc = 65536 + (c.charCodeAt(0) - 55296) * 1024 + (c.charCodeAt(1) - 56320);
    return _fromCC(240 | cc >>> 18 & 7) + _fromCC(128 | cc >>> 12 & 63) + _fromCC(128 | cc >>> 6 & 63) + _fromCC(128 | cc & 63);
  }
};
var re_utob = /[\uD800-\uDBFF][\uDC00-\uDFFFF]|[^\x00-\x7F]/g;
var utob = (u) => u.replace(re_utob, cb_utob);
var _encode = _hasBuffer ? (s) => Buffer.from(s, "utf8").toString("base64") : _TE ? (s) => _fromUint8Array(_TE.encode(s)) : (s) => _btoa(utob(s));
var encode = (src, urlsafe = false) => urlsafe ? _mkUriSafe(_encode(src)) : _encode(src);
var encodeURI = (src) => encode(src, true);
var re_btou = /[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g;
var cb_btou = (cccc) => {
  switch (cccc.length) {
    case 4:
      var cp = (7 & cccc.charCodeAt(0)) << 18 | (63 & cccc.charCodeAt(1)) << 12 | (63 & cccc.charCodeAt(2)) << 6 | 63 & cccc.charCodeAt(3), offset = cp - 65536;
      return _fromCC((offset >>> 10) + 55296) + _fromCC((offset & 1023) + 56320);
    case 3:
      return _fromCC((15 & cccc.charCodeAt(0)) << 12 | (63 & cccc.charCodeAt(1)) << 6 | 63 & cccc.charCodeAt(2));
    default:
      return _fromCC((31 & cccc.charCodeAt(0)) << 6 | 63 & cccc.charCodeAt(1));
  }
};
var btou = (b) => b.replace(re_btou, cb_btou);
var atobPolyfill = (asc) => {
  asc = asc.replace(/\s+/g, "");
  if (!b64re.test(asc))
    throw new TypeError("malformed base64.");
  asc += "==".slice(2 - (asc.length & 3));
  let u24, bin = "", r1, r2;
  for (let i = 0; i < asc.length; ) {
    u24 = b64tab[asc.charAt(i++)] << 18 | b64tab[asc.charAt(i++)] << 12 | (r1 = b64tab[asc.charAt(i++)]) << 6 | (r2 = b64tab[asc.charAt(i++)]);
    bin += r1 === 64 ? _fromCC(u24 >> 16 & 255) : r2 === 64 ? _fromCC(u24 >> 16 & 255, u24 >> 8 & 255) : _fromCC(u24 >> 16 & 255, u24 >> 8 & 255, u24 & 255);
  }
  return bin;
};
var _atob = _hasatob ? (asc) => atob(_tidyB64(asc)) : _hasBuffer ? (asc) => Buffer.from(asc, "base64").toString("binary") : atobPolyfill;
var _toUint8Array = _hasBuffer ? (a) => _U8Afrom(Buffer.from(a, "base64")) : (a) => _U8Afrom(_atob(a), (c) => c.charCodeAt(0));
var toUint8Array = (a) => _toUint8Array(_unURI(a));
var _decode = _hasBuffer ? (a) => Buffer.from(a, "base64").toString("utf8") : _TD ? (a) => _TD.decode(_toUint8Array(a)) : (a) => btou(_atob(a));
var _unURI = (a) => _tidyB64(a.replace(/[-_]/g, (m0) => m0 == "-" ? "+" : "/"));
var decode = (src) => _decode(_unURI(src));
var isValid = (src) => {
  if (typeof src !== "string")
    return false;
  const s = src.replace(/\s+/g, "").replace(/={0,2}$/, "");
  return !/[^\s0-9a-zA-Z\+/]/.test(s) || !/[^\s0-9a-zA-Z\-_]/.test(s);
};
var _noEnum = (v) => {
  return {
    value: v,
    enumerable: false,
    writable: true,
    configurable: true
  };
};
var extendString = function() {
  const _add = (name, body) => Object.defineProperty(String.prototype, name, _noEnum(body));
  _add("fromBase64", function() {
    return decode(this);
  });
  _add("toBase64", function(urlsafe) {
    return encode(this, urlsafe);
  });
  _add("toBase64URI", function() {
    return encode(this, true);
  });
  _add("toBase64URL", function() {
    return encode(this, true);
  });
  _add("toUint8Array", function() {
    return toUint8Array(this);
  });
};
var extendUint8Array = function() {
  const _add = (name, body) => Object.defineProperty(Uint8Array.prototype, name, _noEnum(body));
  _add("toBase64", function(urlsafe) {
    return fromUint8Array(this, urlsafe);
  });
  _add("toBase64URI", function() {
    return fromUint8Array(this, true);
  });
  _add("toBase64URL", function() {
    return fromUint8Array(this, true);
  });
};
var extendBuiltins = () => {
  extendString();
  extendUint8Array();
};
var gBase64 = {
  version,
  VERSION,
  atob: _atob,
  atobPolyfill,
  btoa: _btoa,
  btoaPolyfill,
  fromBase64: decode,
  toBase64: encode,
  encode,
  encodeURI,
  encodeURL: encodeURI,
  utob,
  btou,
  decode,
  isValid,
  fromUint8Array,
  toUint8Array,
  extendString,
  extendUint8Array,
  extendBuiltins
};

// src/tsc-print/Command.ts
var Command = class {
  constructor() {
    __publicField(this, "dot", 8);
    __publicField(this, "cmdContents", []);
  }
  resetDot(dot) {
    this.dot = dot;
  }
  clearCmd() {
    this.cmdContents = [];
  }
  getCmds() {
    return this.cmdContents;
  }
  closePrint() {
    this.setCustomCmd({ closeport: `` });
  }
  clearBuffer() {
    this.setCustomCmdUnShift({ clearbuffer: "" });
  }
  setCustomCmd(cmd) {
    this.cmdContents.push(cmd);
  }
  setCustomCmdUnShift(cmd) {
    this.cmdContents.unshift(cmd);
  }
  setPaper(paper) {
    const { width, height, speed, density, sensor, gapHeight, gapOffset } = paper;
    this.setCustomCmdUnShift({
      setup: `${width},${height},${speed},${density},${sensor},${gapHeight},${gapOffset}`
    });
  }
  openUsb(usbPrinter = "") {
    return { openport_usb: usbPrinter };
  }
  openNet(connection) {
    const { networkIp, networkPort } = connection;
    return { openport_net: `${networkIp},${networkPort}` };
  }
  commandCrlf(cmd) {
    this.setCustomCmd({ sendcommand_crlf: cmd });
  }
  sendUint8Array(uint8_arr) {
    this.setCustomCmdUnShift({ sendUint8Array: gBase64.fromUint8Array(uint8_arr) });
  }
  printlabel(lq = { sets: 1, copies: 1 }) {
    this.setCustomCmd({ printlabel: lq.sets + "," + lq.copies });
  }
  addBarCode(bc) {
    const { dot } = this;
    const dfData = {
      type: "128",
      readable: 2,
      rotation: 0
    };
    bc = __spreadValues(__spreadValues({}, dfData), bc);
    let cmd = `${bc.x * dot},${bc.y * dot},"${bc.type}",${bc.height * dot},${bc.readable},${bc.rotation},${bc.narrow * dot},${bc.wide * dot}`;
    if (bc.code.charAt(0) == "@") {
      cmd += `,${bc.code}`;
    } else {
      cmd += `,"${bc.code}"`;
    }
    this.setCustomCmd({ barcode: cmd });
  }
  addQrCode(q) {
    const { dot } = this;
    const dfData = {
      eccLevel: "Q",
      mode: "A",
      rotation: 0,
      model: "M2",
      mask: "S7"
    };
    q = __spreadValues(__spreadValues({}, dfData), q);
    let cmd = `${q.x * dot},${q.y * dot},${q.eccLevel},${q.cellWidth},${q.mode},${q.rotation},${q.model},${q.mask},"${q.content}"`;
    this.commandCrlf(`QRCODE ${cmd}`);
  }
  addFont(q) {
    const { dot } = this;
    const dfData = {
      rotation: 0,
      fontstyle: 0,
      fontunderline: 0,
      szFaceName: "Arial"
    };
    q = __spreadValues(__spreadValues({}, dfData), q);
    let cmd = `${q.x * dot},${q.y * dot},${q.fontheight * dot},${q.rotation},${q.fontstyle},${q.fontunderline},${q.szFaceName},${q.text}`;
    this.setCustomCmd({ windowsfont: cmd });
  }
};

// src/tsc-print/Socket.ts
var Socket = class {
  constructor(connection) {
    __publicField(this, "connection");
    this.connection = connection;
  }
  getSocketUrl() {
    const { socketIp, socketPort } = this.connection;
    return `ws://${socketIp}:${socketPort}`;
  }
  send(data) {
    let resData = [];
    return new Promise((resolve, reject) => {
      const websocket = new WebSocket(this.getSocketUrl());
      websocket.onopen = function(e) {
        let sendData = JSON.stringify(data);
        try {
          websocket.send(sendData);
        } catch (e2) {
          reject(`\u53D1\u9001\u6570\u636E\u5F02\u5E38: ${data}`);
        }
      };
      websocket.onmessage = function(event) {
        if (event.data == "Finished") {
          websocket.close();
        } else {
          try {
            const obj = JSON.parse(event.data);
            if ("Function_Failed" in obj) {
              reject(`\u5931\u8D25: ${event.data}`);
            } else {
              resData.push(obj);
            }
          } catch (e) {
            reject(`\u6536\u5230\u6570\u636E\u5F02\u5E38: ${event.data}`);
          }
        }
      };
      websocket.onclose = function(event) {
        if (event.code === 1e3) {
          resolve(resData);
        } else {
          let reason = "";
          if (event.code == 1001)
            reason = 'An endpoint is "going away", such as a server going down or a browser having navigated away from a page.';
          else if (event.code == 1002)
            reason = "An endpoint is terminating the connection due to a protocol error";
          else if (event.code == 1003)
            reason = "An endpoint is terminating the connection because it has received a type of data it cannot accept (e.g., an endpoint that understands only text data MAY send this if it receives a binary message).";
          else if (event.code == 1004)
            reason = "Reserved. The specific meaning might be defined in the future.";
          else if (event.code == 1005)
            reason = "No status code was actually present.";
          else if (event.code == 1006)
            reason = "The connection was closed abnormally, e.g., without sending or receiving a Close control frame";
          else if (event.code == 1007)
            reason = "An endpoint is terminating the connection because it has received data within a message that was not consistent with the type of the message (e.g., non-UTF-8 [https://www.rfc-editor.org/rfc/rfc3629] data within a text message).";
          else if (event.code == 1008)
            reason = 'An endpoint is terminating the connection because it has received a message that "violates its policy". This reason is given either if there is no other sutible reason, or if there is a need to hide specific details about the policy.';
          else if (event.code == 1009)
            reason = "An endpoint is terminating the connection because it has received a message that is too big for it to process.";
          else if (event.code == 1010)
            reason = "An endpoint (client) is terminating the connection because it has expected the server to negotiate one or more extension, but the server didn't return them in the response message of the WebSocket handshake. <br /> Specifically, the extensions that are needed are: " + event.reason;
          else if (event.code == 1011)
            reason = "A server is terminating the connection because it encountered an unexpected condition that prevented it from fulfilling the request.";
          else if (event.code == 1015)
            reason = "The connection was closed due to a failure to perform a TLS handshake (e.g., the server certificate can't be verified).";
          else
            reason = "Unknown reason";
          reject(`error: code=${event.code}, reason=${reason}`);
        }
      };
      websocket.onerror = function(error) {
        reject(error);
      };
    });
  }
};

// src/tsc-print/TscPrint.ts
var TscPrint = class extends Command {
  constructor(paper, connection) {
    super();
    __publicField(this, "paper");
    __publicField(this, "usbPrintList", []);
    __publicField(this, "connection");
    __publicField(this, "socket");
    this.paper = this.paperInit(paper);
    this.connection = this.connectInfoInit(connection || {});
    this.socket = new Socket(this.connection);
    this.getUsbPrintList();
  }
  paperInit(paper) {
    const defaultPaper = {
      speed: 8,
      density: 8,
      sensor: 0,
      gapOffset: 0
    };
    const _paper = __spreadValues(__spreadValues({}, defaultPaper), paper);
    const { width, height, gapHeight } = _paper;
    if (!width)
      throw "\u8BF7\u8BBE\u7F6E\u7EB8\u5F20\u5BBD\u5EA6";
    if (!height)
      throw "\u8BF7\u8BBE\u7F6E\u7EB8\u5F20\u9AD8\u5EA6";
    if (gapHeight === void 0)
      throw "\u8BF7\u8BBE\u7F6E\u7EB8\u5F20\u95F4\u9699";
    return _paper;
  }
  connectInfoInit(connection) {
    const defaultConnect = {
      printType: 0,
      socketIp: "127.0.0.1",
      socketPort: "8888"
    };
    const _connection = __spreadValues(__spreadValues({}, defaultConnect), connection);
    const { printType, networkIp, networkPort } = _connection;
    if (printType == 1 && (!networkIp || !networkPort)) {
      throw "\u8BF7\u6B63\u786E\u914D\u7F6E\u7F51\u7EDC\u6253\u5370\u4FE1\u606F";
    }
    return _connection;
  }
  getListData(list, key) {
    const taget = list.filter((item) => item[key]);
    return taget.length ? taget[0][key] : void 0;
  }
  getPrintMethod(usbPath) {
    var _a;
    if (this.connection.printType === 0) {
      return this.openUsb(usbPath || ((_a = this.usbPrintList[0]) == null ? void 0 : _a.USBPath));
    } else {
      return this.openNet(this.connection);
    }
  }
  socketSend(usbPath) {
    this.setCustomCmdUnShift(this.getPrintMethod(usbPath));
    this.closePrint();
    let obj = { functions_inorder: this.getCmds() };
    return this.socket.send(obj).finally(() => {
      this.clearCmd();
    });
  }
  getSelfTest(usbPath) {
    this.commandCrlf("SELFTEST");
    return this.socketSend(usbPath);
  }
  getUsbPrintList() {
    return this.socket.send({ usb_list: [] }).then((list) => {
      this.usbPrintList = this.getListData(list, "usb_list") || [];
      return this.usbPrintList;
    });
  }
  getPrintState(usbPath) {
    this.setCustomCmd({ printerstatus: "" });
    this.setCustomCmd({ printername: "" });
    this.setCustomCmd({ printerserial: "" });
    return this.socketSend(usbPath);
  }
  startPrint(usbPath, lq) {
    if (this.getCmds().length === 0) {
      console.warn("tsc-print: \u6CA1\u6709\u8BBE\u7F6E\u4EFB\u4F55\u6253\u5370\u5185\u5BB9");
    }
    this.setPaper(this.paper);
    this.clearBuffer();
    const u8 = new Uint8Array([13, 10]);
    this.sendUint8Array(u8);
    this.printlabel(lq);
    return this.socketSend(usbPath);
  }
};


exports.default = TscPrint;
